{$X+}
USES

  crt, graph;

VAR

  gd, gm : integer;
  orgx, orgy : integer;

PROCEDURE PressAnyKey;

  begin

    while keypressed do readkey;
    Repeat until keypressed;
    while keypressed do readkey;

  end;


PROCEDURE DrawCube(X1,Y1,Z1, X2,Y2,Z2, teller : integer);

  type

    rechthoek = record
      P1X, P1Y : integer;
      P2X, P2Y : integer;
      P3X, P3Y : integer;
      P4X, P4Y : integer;
      end;

  var

    X3, Y3, Z3 : integer;
    R : rechthoek;


  begin

    if teller=0 then
      begin
      X3:=orgx;
      Y3:=orgy;
      SetColor(1);
      SetFillStyle(Solidfill,1);
      with R do
        begin
        P1X:=X3+X1-Z1;
        P1Y:=Y3+Y1-X1-Z1;
        P2X:=X3+X2-Z1;
        P2Y:=Y3+Y1-X2-Z1;
        P3X:=X3+X2-Z2;
        P3Y:=Y3+Y1-X2-Z2;
        P4X:=X3+X1-Z2;
        P4Y:=Y3+Y1-X1-Z2;
        end;
      FillPoly(4,R);
      SetFillStyle(Solidfill,2);
      Setcolor(2);
      with R do
        begin
        P1X:=X3+X1-Z1;
        P1Y:=Y3+Y1-X1-Z1;
        P2X:=X3+X2-Z1;
        P2Y:=Y3+Y1-X2-Z1;
        P3X:=X3+X2-Z1;
        P3Y:=Y3+Y2-X2-Z1;
        P4X:=X3+X1-Z1;
        P4Y:=Y3+Y2-X1-Z1;
        end;
      FillPoly(4,R);
      SetFillStyle(Solidfill,3);
      SetColor(3);
      with R do
        begin
        P1X:=X3+X1-Z1;
        P1Y:=Y3+Y1-X1-Z1;
        P2X:=X3+X1-Z2;
        P2Y:=Y3+Y1-X1-Z2;
        P3X:=X3+X1-Z2;
        P3Y:=Y3+Y2-X1-Z2;
        P4X:=X3+X1-Z1;
        P4Y:=Y3+Y2-X1-Z1;
        end;
      FillPoly(4,R);

      end else

      begin
      X3:=(X2-X1) div 3;
      Y3:=(Y2-Y1) div 3;
      Z3:=(Z2-Z1) div 3;

      DrawCube(X2-X3,Y2-Y3,Z2-Z3,X2,Y2,Z2,teller-1);
      DrawCube(X2-X3,Y1+Y3,Z2-Z3,X2,Y2-Y3,Z2,teller-1);
      DrawCube(X1+X3,Y2-Y3,Z2-Z3,X2-X3,Y2,Z2,teller-1);
      DrawCube(X2-X3,Y2-Y3,Z1+Z3,X2,Y2,Z2-Z3,teller-1);
      DrawCube(X2-X3,Y1,Z2-Z3,X2,Y1+Y3,Z2,teller-1);
      DrawCube(X1+X3,Y1,Z2-Z3,X2-X3,Y1+Y3,Z2,teller-1);
      DrawCube(X2-X3,Y1,Z1+Z3,X2,Y1+Y3,Z2-Z3,teller-1);
      DrawCube(X1,Y2-Y3,Z2-Z3,X1+X3,Y2,Z2,teller-1);
      DrawCube(X1,Y1+Y3,Z2-Z3,X1+X3,Y2-Y3,Z2,teller-1);
      DrawCube(X1,Y1,Z2-Z3,X1+X3,Y1+Y3,Z2,teller-1);
      DrawCube(X2-X3,Y2-Y3,Z1,X2,Y2,Z1+Z3,teller-1);
      DrawCube(X2-X3,Y1+Y3,Z1,X2,Y2-Y3,Z1+Z3,teller-1);
      DrawCube(X2-X3,Y1,Z1,X2,Y1+Y3,Z1+Z3,teller-1);
      DrawCube(X1,Y2-Y3,Z1+Z3,X1+X3,Y2,Z2-Z3,teller-1);
      DrawCube(X1+X3,Y2-Y3,Z1,X2-X3,Y2,Z1+Z3,teller-1);
      DrawCube(X1,Y1,Z1+Z3,X1+X3,Y1+Y3,Z2-Z3,teller-1);
      DrawCube(X1+X3,Y1,Z1,X2-X3,Y1+Y3,Z1+Z3,teller-1);
      DrawCube(X1,Y2-Y3,Z1,X1+X3,Y2,Z1+Z3,teller-1);
      DrawCube(X1,Y1+Y3,Z1,X1+X3,Y2-Y3,Z1+Z3,teller-1);
      DrawCube(X1,Y1,Z1,X1+X3,Y1+Y3,Z1+Z3,teller-1);

      end;

  end;


VAR

  teller :integer;

BEGIN

  Gd:=detect;
  Initgraph(gd,gm,'c:\tp\bgi');
  orgx:=getmaxx div 2;
  orgy:=315;
  for teller:=1 to 6 do
    begin
    ClearViewPort;
    DrawCube(
    0,0,0,
    165,165,165,
    teller);
    pressanykey;
    end;

END.
