PROGRAM KochKromme;

USES

  General,
  Graph;

CONST

  Totalelengte : real = 0;


FUNCTION XDeelVan(X1,Y1,X2,Y2 : integer; factor : real) : integer;

  begin

    XDeelVan:=round((X2-X1)*factor)+X1

  end;


FUNCTION YDeelVan(X1,Y1,X2,Y2 : integer; factor : real) : integer;

  begin

    YDeelVan:=round((Y2-Y1)*factor)+Y1

  end;



function Verschil(getal1, getal2 : integer) : integer;

  begin

    Verschil:=abs(getal1-Getal2);

  end;


function sign(Aval : integer) : integer;

  begin

    if AVal>=0
      then Sign:=1
      else
        begin
         if aval=0
          then sign:=0
          else sign:=-1;
        end;

  end;


FUNCTION XPuntVan(X1,Y1,X2,Y2 : integer) : integer;

    begin

      XPuntVan:=((X2-X1) div 2)+X1 - (Verschil(Y2,Y1) div 3) * sign(Y1-Y2);

    end;


FUNCTION YPuntVan(X1,Y1,X2,Y2 : integer) : integer;

    begin

      YPuntVan:=((Y2-Y1) div 2)+Y1 - (Verschil(X2,X1) div 3) * sign(X2-X1);

    end;


FUNCTION Lengte(X1,Y1,X2,Y2 : integer) : real;

    begin

      Lengte:=sqrt((longint(X2)-longint(X1))*(longint(X2)-longint(X1))+(longint(Y2)-longint(Y1))*(longint(Y2)-longint(Y1)));

    end;


PROCEDURE Lijn(X1,Y1,X2,Y2 : integer; diepte : integer);


  begin

    If diepte=0
      then
        begin
        Line(X1,Y1,X2,Y2);
        TotaleLengte:=TotaleLengte+Lengte(X1,Y1,X2,Y2);
        end
      else
        begin
        Lijn(X1,Y1,XDeelVan(X1,Y1,X2,Y2,1/3),YDeelVan(X1,Y1,X2,Y2,1/3),diepte-1);
        Lijn(XDeelVan(X1,Y1,X2,Y2,1/3),YDeelVan(X1,Y1,X2,Y2,1/3),XPuntVan(X1,Y1,X2,Y2),YPuntVan(X1,Y1,X2,Y2),diepte-1);
        Lijn(XPuntVan(X1,Y1,X2,Y2),YPuntVan(X1,Y1,X2,Y2),XDeelVan(X1,Y1,X2,Y2,2/3),YDeelVan(X1,Y1,X2,Y2,2/3),diepte-1);
        Lijn(XDeelVan(X1,Y1,X2,Y2,2/3),YDeelVan(X1,Y1,X2,Y2,2/3),X2,Y2,diepte-1);
        end;

  end;


VAR

  gd, gm : integer;
  teller : integer;

BEGIN

  gd:=detect;
  Initgraph(gd,gm,'c:\tp\bgi');
  for teller:=1 to 7 do
    begin
    ClearViewPort;
    TotaleLengte:=0;
    Lijn(0,getmaxy div 2,getmaxx, getmaxy div 2,teller);
    OutTextXY(10,GetMaxY-8,'Lengte : '+Int2Str(round(totalelengte)));
    Pressanykey;
    end;
  closegraph;

END.

